<?php
/* Reminder: always indent with 4 spaces (no tabs). */
// +---------------------------------------------------------------------------+
// | Geeklog FAQ Plugin 0.8 for Geeklog - The Ultimate Weblog                  |
// | Official release date: Mar 9,2003                                         |
// +---------------------------------------------------------------------------+
// | FAQ Man Plugin Install.php                                                |
// | This program creates the required table structure and core Geeklog        |
// | database updates to complete installation of this plugin                  |
// +---------------------------------------------------------------------------+
// | Copyright (C) 2000,2001,2002,2003 by the following authors:               |
// | Geeklog Author: Tony Bibbs       - tony@tonybibbs.com                     |
// +---------------------------------------------------------------------------+
// | FAQ Plugin Author                                                         |
// | Authors: FAQ Appllication:   Stephen Ball, stephen@aquonics.com           |
// | Conversion to Geeklog Plugin: Blaine Lang, blaine@portalparts.com          |
// +---------------------------------------------------------------------------+
// |                                                                           |
// | Stephen Ball, the author of FAQ Manager gave me (Blaine Lang) permission  |
// | to create this Geeklog Plugin using his application and make it available |
// | to the Geeklog community.                                                 |
// |                                                                           |
// | This program is distributed in the hope that it will be useful,           |
// | but WITHOUT ANY WARRANTY; without even the implied warranty of            |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
// | GNU General Public License for more details.                              |
// |                                                                           |
// | You should have received a copy of the GNU General Public License         |
// | along with this program; if not, write to the Free Software Foundation,   |
// | Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.           |
// |                                                                           |
// +---------------------------------------------------------------------------+
//

require_once('../../../lib-common.php');
require_once($_CONF['path'] . 'plugins/faqman/config.php');
require_once($_CONF['path'] . 'plugins/faqman/functions.inc');

//
// Universal plugin install variables
// Change these to match your plugin
//

$pi_name = 'faqman';                    // Plugin name
$pi_version = '0.8';                    // Plugin Version
$gl_version = '1.3.7';                  // GL Version plugin for
$pi_url = 'http://www.portalparts.com';   // Plugin Homepage


// Default data
// Insert table name and sql to insert default data for your plugin.

$DEFVALUES = array();

// Example default data


//
// Security Feature to add
// Fill in your security features here
// Note you must add these features to the uninstall routine in function.inc so that they will
// be removed when the uninstall routine runs.
// You do not have to use these particular features.  You can edit/add/delete them
// to fit your plugins security model
//

$NEWFEATURE = array();
$NEWFEATURE['faqman.edit']="FAQ Manager Admin";
$NEWFEATURE['faqman.user']="FAQ Manager Viewer";


// Only let Root users access this page
if (!SEC_inGroup('Root')) {
    // Someone is trying to illegally access this page
    COM_errorLog("Someone has tried to illegally access the faqman install/uninstall page.  User id: {$_USER['uid']}, Username: {$_USER['username']}, IP: $REMOTE_ADDR",1);
    $display = COM_siteHeader();
    $display .= COM_startBlock($LANG_FAQ['access_denied']);
    $display .= $LANG_FAQ['access_denied_msg'];
    $display .= COM_endBlock();
    $display .= COM_siteFooter(true);
    echo $display;
    exit;
}
 
/**
* Puts the datastructures for this plugin into the Geeklog database
*
* Note: Corresponding uninstall routine is in functions.inc
* 
* @return	boolean	True if successful False otherwise
*
*/
function plugin_install_faqman()
{
    global $pi_name, $pi_version, $gl_version, $pi_url, $NEWTABLE, $DEFVALUES, $NEWFEATURE;
    global $_TABLES, $_CONF;

    COM_errorLog("Attempting to install the $pi_name Plugin",1);

    // Create the Plugins Tables
    
    require_once($_CONF['path'] . 'plugins/faqman/faqman_sql_1.0.php');
	for ($i = 1; $i <= count($_SQL); $i++) {
	    $progress .= "executing " . current($_SQL) . "<br>\n";
	    COM_errorLOG("executing " . current($_SQL));
		DB_query(current($_SQL));
        if (DB_error()) {
            COM_errorLog("Error Creating $table table",1);
            plugin_uninstall_faqman('DeletePlugin');
            return false;
            exit;
        }
	    next($_SQL);
	}
    COM_errorLog("Success - Created $table table",1);
       
    // Insert Default Data
    
    foreach ($DEFVALUES as $table => $sql) {
        COM_errorLog("Inserting default data into $table table",1);
        DB_query($sql,1);
        if (DB_error()) {
            COM_errorLog("Error inserting default data into $table table",1);
            plugin_uninstall_faqman();
            return false;
            exit;
        }
        COM_errorLog("Success - inserting data into $table table",1);
    }
    
    // Create the plugin admin security group
    COM_errorLog("Attempting to create $pi_name admin group", 1);
    DB_query("INSERT INTO {$_TABLES['groups']} (grp_name, grp_descr) "
        . "VALUES ('$pi_name Admin', 'Users in this group can administer the $pi_name plugin')",1);
    if (DB_error()) {
        plugin_uninstall_faqman();
        return false;
        exit;
    }
    COM_errorLog('...success',1);
    $group_id = DB_insertId();
    
    // Save the grp id for later uninstall
    COM_errorLog('About to save group_id to vars table for use during uninstall',1);
    DB_query("INSERT INTO {$_TABLES['vars']} VALUES ('{$pi_name}_admin', $group_id)",1);
    if (DB_error()) {
        plugin_uninstall_faqman();
        return false;
        exit;
    }
    COM_errorLog('...success',1);
    
    // Add plugin Features
    foreach ($NEWFEATURE as $feature => $desc) {
        COM_errorLog("Adding $feature feature",1);
        DB_query("INSERT INTO {$_TABLES['features']} (ft_name, ft_descr) "
            . "VALUES ('$feature','$desc')",1);
        if (DB_error()) {
            COM_errorLog("Failure adding $feature feature",1);
            plugin_uninstall_faqman();
            return false;
            exit;
        }
        $feat_id = DB_insertId();
        COM_errorLog("Success",1);
        COM_errorLog("Adding $feature feature to admin group",1);
        DB_query("INSERT INTO {$_TABLES['access']} (acc_ft_id, acc_grp_id) VALUES ($feat_id, $group_id)");
        if (DB_error()) {
            COM_errorLog("Failure adding $feature feature to admin group",1);
            plugin_uninstall_faqman();
            return false;
            exit;
        }
        COM_errorLog("Success",1);
    }        
    
    // OK, now give Root users access to this plugin now! NOTE: Root group should always be 1
    COM_errorLog("Attempting to give all users in Root group access to $pi_name admin group",1);
    DB_query("INSERT INTO {$_TABLES['group_assignments']} VALUES ($group_id, NULL, 1)");
    if (DB_error()) {
        plugin_uninstall_faqman();
        return false;
        exit;
    }

    // Register the plugin with Geeklog
    COM_errorLog("Registering $pi_name plugin with Geeklog", 1);
    DB_delete($_TABLES['plugins'],'pi_name','faqman');
    DB_query("INSERT INTO {$_TABLES['plugins']} (pi_name, pi_version, pi_gl_version, pi_homepage, pi_enabled) "
        . "VALUES ('$pi_name', '$pi_version', '$gl_version', '$pi_url', 1)");

    if (DB_error()) {
        plugin_uninstall_faqman();
        return false;
        exit;
    }

    COM_errorLog("Succesfully installed the $pi_name Plugin!",1);
    return true;
}

/* 
* Main Function
*/

$display = COM_siteHeader();
$T = new Template($_CONF['path'] . 'plugins/faqman/templates');
$T->set_file('install', 'install.thtml');
$T->set_var('install_header', $LANG_FAQ['install_header']);
$T->set_var('img',$_CONF['site_url'] . '/faqman/images/faqman.gif');
$T->set_var('cgiurl', $_CONF['site_admin_url'] . '/plugins/faqman/install.php');
$T->set_var('admin_url', $_CONF['site_admin_url'] . '/plugins/faqman/index.php');

if ($action == 'install') {
    if (plugin_install_faqman()) {
        $install_msg = sprintf($LANG_FAQ['install_success'],$_CONF['site_admin_url'] .'/plugins/faqman/install_doc.htm');
		$T->set_var('installmsg1',$install_msg);
    } else {
        $T->set_var('installmsg1',$LANG_FAQ['install_failed']);
    }
} else if ($action == "uninstall") {
   plugin_uninstall_faqman('installed');
   $T->set_var('installmsg1',$LANG_FAQ['uninstall_msg']);
}

if (DB_count($_TABLES['plugins'], 'pi_name', 'faqman') == 0) {
    $T->set_var('installmsg2', $LANG_FAQ['uninstalled']);
	$T->set_var('btnmsg', $LANG_FAQ['install']);
	$T->set_var('action','install');
} else {
    $T->set_var('installmsg2', $LANG_FAQ['installed']);
	$T->set_var('btnmsg', $LANG_FAQ['uninstall']);
	$T->set_var('action','uninstall');
}
$T->parse('output','install');
$display .= $T->finish($T->get_var('output'));
$display .= COM_siteFooter(true);

echo $display;

?>